#include "stdafx.h"
#include "Config.h"

#define WM_MENU98 0x0409
#define SHOWMENU 0x90
#define EXITHOST 0x91

/*
static HWND FindHWND() {
	HWND h = FindWindow(TEXT("Shell_TrayWnd"), nullptr);
	if (IsWindow(h))
		return FindWindowEx(h, 0, TEXT("TrayButton"), nullptr);
	return nullptr;
}
*/


int main(int argc, char * argv[])
{
	HWND hWndButton;

	if (argc == 3) {
		if (strcmp(argv[1], "/close") == 0) {
			hWndButton = FindWindowA(argv[2], nullptr);
			SendMessage(hWndButton, WM_MENU98, EXITHOST, 0);
		}

		return 0;
	}

	if (argc == 4) {
		if (strcmp(argv[1], "/close") == 0) {
			hWndButton = FindWindowA(argv[2], nullptr);
			hWndButton = FindWindowExA(hWndButton, 0, argv[3], nullptr);
			SendMessage(hWndButton, WM_MENU98, EXITHOST, 0);
		}
	
		return 0;
	}


	hWndButton = Config_GetButtonHandle();// FindWindow(L"Button", nullptr);

	if (!IsWindow(hWndButton))
		return -1;

	DWORD ProcessID;
	DWORD ThreadID = GetWindowThreadProcessId(hWndButton, &ProcessID);

	
	if (argc == 1) {
		SendMessage(hWndButton, WM_MENU98, EXITHOST, 0);
		return 0;
	}
	else if (argc != 2) {
		return 0;
	}


	HANDLE hProcess = OpenProcess(PROCESS_VM_OPERATION | PROCESS_VM_WRITE | PROCESS_ALL_ACCESS, FALSE, ProcessID);
	if (hProcess == NULL) {
		MessageBox(0, L"Unable to obtain the explorer handler", L"Error", 0);
		return -1;
	}

	LPCSTR lpDllName = argv[1];

#ifdef _M_IX86
	DWORD dwSize = strlen(lpDllName) + 1;
	DWORD dwHasWrite;
#endif

#ifdef _M_X64
	SIZE_T dwSize = strlen(lpDllName) + 1;
	SIZE_T dwHasWrite;
#endif

	LPVOID lpRemoteBuf = VirtualAllocEx(hProcess, NULL, dwSize, MEM_COMMIT, PAGE_READWRITE);
	if (WriteProcessMemory(hProcess, lpRemoteBuf, lpDllName, dwSize, &dwHasWrite)) {
		if (dwHasWrite != dwSize) {
			VirtualFreeEx(hProcess, lpRemoteBuf, dwSize, MEM_COMMIT);
			CloseHandle(hProcess);
			return -1;
		}

	}
	else {
		MessageBox(0, L"Fail to write the remote process memory", L"Error", 0);
		CloseHandle(hProcess);
		return -1;
	}

	DWORD dwNewThreadId;
	LPVOID lpLoadDll = LoadLibraryA;
	HANDLE hNewRemoteThread = CreateRemoteThread(hProcess, NULL, 0, (LPTHREAD_START_ROUTINE)lpLoadDll, lpRemoteBuf, 0, &dwNewThreadId);
	if (hNewRemoteThread == NULL) {
		MessageBox(0, L"Fail to build the remote thread", L"Error", 0);
		CloseHandle(hProcess);
		return -1;
	}



	WaitForSingleObject(hNewRemoteThread, INFINITE);
	CloseHandle(hNewRemoteThread);

	return 0;

	/*
	//׼ж֮ǰעDll 
	DWORD dwHandle, dwID;
	LPVOID pFunc = GetModuleHandleA;//Զ߳бעDllľ 
	HANDLE hThread = CreateRemoteThread(hProcess, NULL, 0, (LPTHREAD_START_ROUTINE)pFunc, lpRemoteBuf, 0, &dwID);
	WaitForSingleObject(hThread, INFINITE);
	GetExitCodeThread(hThread, &dwHandle);//̵߳Ľ뼴ΪDllģľ 
	CloseHandle(hThread);
	pFunc = FreeLibrary;
	hThread = CreateRemoteThread(hThread, NULL, 0, (LPTHREAD_START_ROUTINE)pFunc, (LPVOID)dwHandle, 0, &dwID); //FreeLibraryAע뵽Զ߳ȥжDll 
	WaitForSingleObject(hThread, INFINITE);
	CloseHandle(hThread);
	CloseHandle(hProcess);
	*/

    return 0;
}

