#include "stdafx.h"
#include "Config.h"

MSXML2::IXMLDOMDocumentPtr cfgDoc;
MSXML2::IXMLDOMElementPtr cfgRoot;

void Config_Load(LPWSTR path) {
	CoInitialize(NULL);
	cfgDoc.CreateInstance(__uuidof(MSXML2::DOMDocument30));
	cfgDoc->load(path);
	cfgRoot = cfgDoc->documentElement;
}

void Config_Unload() {
	cfgRoot.Release();
	cfgDoc.Release();
	CoUninitialize();
}



bool Config_GetButton(LPWSTR* buttonName) {
	_bstr_t bstr;

	bstr = cfgRoot->attributes->getNamedItem(L"button")->text;
	*buttonName = (LPWSTR)malloc(sizeof(LPWSTR) * lstrlen(bstr));
	lstrcpy(*buttonName, bstr);
	//SysFreeString(bstr);

	bstr = cfgRoot->attributes->getNamedItem(L"tray")->text;
	if (lstrcmp(bstr, L"1") == 0) {
		//SysFreeString(bstr);
		return true;
	}
	else {
		//SysFreeString(bstr);
		return false;
	}
}